#include "ProceduralGenerator/PrecompiledHeader.h"

#include "ProceduralGenerator/ProjectListDialog.h"

#ifdef __WXMSW__
#	include<wx/msw/msvcrt.h>
#endif

using namespace ProceduralTextures;

//*************************************************************************************************

ProjectListDialog :: ProjectListDialog( wxWindow * p_parent, const wxArrayString & p_choices)
	:	wxDialog( p_parent, wxID_ANY, wxT( "Choose a generator"), wxDefaultPosition, wxSize( 400, 20 + wxDEFAULT_HEIGHT * 6 ) )
{
	SetClientSize( wxSize( 400, 20 + wxDEFAULT_HEIGHT * 6 ) );

	if (p_choices.size() > 0)
	{
								new wxStaticText(	this, wxID_ANY,		wxT( "Generator"),		wxPoint(  10, 10 + wxDEFAULT_HEIGHT * 0	), wxSize( 170, wxDEFAULT_HEIGHT ) );
		m_pComboProjets =		new wxComboBox(		this, pldProjects,	p_choices[0],			wxPoint(  20, 10 + wxDEFAULT_HEIGHT * 1	), wxSize( 360, wxDEFAULT_HEIGHT ), p_choices, wxCB_READONLY);

		wxArrayString l_arrayResolutions;
		l_arrayResolutions.push_back( wxT( "256"));
		l_arrayResolutions.push_back( wxT( "384"));
		l_arrayResolutions.push_back( wxT( "512"));
		l_arrayResolutions.push_back( wxT( "768"));
		l_arrayResolutions.push_back( wxT( "1024"));

		m_pStaticResolution =	new wxStaticText(	this, wxID_ANY,		wxT( "Screen Size" ),	wxPoint(  10, 10 + wxDEFAULT_HEIGHT * 2 ), wxSize( 80, wxDEFAULT_HEIGHT ) );
		m_pComboWidth =			new wxComboBox(		this, wxID_ANY,		l_arrayResolutions[0],	wxPoint(  90, 10 + wxDEFAULT_HEIGHT * 3 ), wxSize( 80, wxDEFAULT_HEIGHT ), l_arrayResolutions, wxCB_READONLY);
		m_pComboHeight =		new wxComboBox(		this, wxID_ANY,		l_arrayResolutions[0],	wxPoint( 170, 10 + wxDEFAULT_HEIGHT * 3 ), wxSize( 80, wxDEFAULT_HEIGHT ), l_arrayResolutions, wxCB_READONLY);
	}

								new wxStaticLine(	this, wxID_ANY,								wxPoint(  10, 20 + wxDEFAULT_HEIGHT * 4 ), wxSize( 380, 2));

								new wxButton(		this, pldOK,		wxT( "OK" ),			wxPoint( 300, 10 + wxDEFAULT_HEIGHT * 5 ), wxSize( 80, wxDEFAULT_HEIGHT ) );
								new wxButton(		this, pldCancel,	wxT( "Cancel"),			wxPoint(  20, 10 + wxDEFAULT_HEIGHT * 5 ), wxSize( 80, wxDEFAULT_HEIGHT ) );

}

ProjectListDialog :: ~ProjectListDialog()
{
}

wxString ProjectListDialog :: GetProject()
{
	return m_pComboProjets->GetValue();
}

wxSize ProjectListDialog :: GetResolution()
{
	wxSize l_sizeReturn;

	int l_iWidth = atoi( m_pComboWidth->GetValue().char_str());
	int l_iHeight = atoi( m_pComboHeight->GetValue().char_str());

	l_sizeReturn.Set( l_iWidth, l_iHeight);

	return l_sizeReturn;
}

BEGIN_EVENT_TABLE( ProjectListDialog, wxDialog)
	EVT_CLOSE(						ProjectListDialog::_onClose)
	EVT_BUTTON(		pldOK,			ProjectListDialog::_onOK)
	EVT_BUTTON(		pldCancel,		ProjectListDialog::_onCancel)
	EVT_COMBOBOX(	pldProjects,	ProjectListDialog::_onProjects)
END_EVENT_TABLE()

void ProjectListDialog :: _onClose( wxCloseEvent & event)
{
	EndModal( wxID_CANCEL);
}

void ProjectListDialog :: _onOK( wxCommandEvent& event)
{
	EndModal( wxID_OK);
}

void ProjectListDialog :: _onCancel( wxCommandEvent& event)
{
	EndModal( wxID_CANCEL);
}

void ProjectListDialog :: _onProjects( wxCommandEvent& event)
{
	if (event.GetString() == wxT( "Image Effects") || event.GetString() == wxT( "Shader Effects") || event.GetString() == wxT( "Text Effects"))
	{
		m_pComboHeight->Hide();
		m_pComboWidth->Hide();
		m_pStaticResolution->Hide();
	}
	else
	{
		m_pComboHeight->Show();
		m_pComboWidth->Show();
		m_pStaticResolution->Show();
	}
}

//*************************************************************************************************
